# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Algorithm-Diff-XS
Version:	0.04
Release:	25.%{__distinit}%{__distvers}
Summary:	Algorithm::Diff with XS core loop
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Algorithm-Diff-XS
Source0:	https://cpan.metacpan.org/modules/by-module/Algorithm/Algorithm-Diff-XS-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(lib)
BuildRequires:	perl(strict)
# Dependencies of bundled Module::Install
BuildRequires:	perl(Config)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(YAML)
# Module Runtime
BuildRequires:	perl(Algorithm::Diff) >= 1.19
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Test)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(XSLoader)

# Avoid provides for private shared objects
%{?perl_default_filter}

%description
This module is a simple re-packaging of Joe Schaefer's excellent but not very
well-known Algorithm::LCS with a drop-in interface that simply re-uses the
installed version of the Algorithm::Diff module.

Note that only the LCSidx function is optimized in XS at the moment, which
means only compact_diff will get significantly faster for large data sets,
while diff and sdiff will run in identical speed as Algorithm::Diff.

%prep
%setup -q -n Algorithm-Diff-XS-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README
%{perl_vendorarch}/auto/Algorithm/
%{perl_vendorarch}/Algorithm/
%{_mandir}/man3/Algorithm::Diff::XS.3*

%changelog
* Tue Jul 11 2023 Paul Howarth <paul@city-fan.org> - 0.04-25
- Perl 5.38 rebuild

* Wed Jun  1 2022 Paul Howarth <paul@city-fan.org> - 0.04-22
- Perl 5.36 rebuild

* Fri May 21 2021 Paul Howarth <paul@city-fan.org> - 0.04-18
- Perl 5.34 rebuild

* Thu Jun 25 2020 Paul Howarth <paul@city-fan.org> - 0.04-16
- Perl 5.32 rebuild

* Fri May 31 2019 Paul Howarth <paul@city-fan.org> - 0.04-13
- Perl 5.30 rebuild

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 0.04-9
- Perl 5.28 rebuild

* Mon Mar 19 2018 Paul Howarth <paul@city-fan.org> - 0.04-6
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13:
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally

* Thu Aug  4 2016 Paul Howarth <paul@city-fan.org> - 0.04-5
- Classify buildreqs by usage
- Simplify find commands using -empty and -delete

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.04-4
- Drop %%defattr, redundant since rpm 4.4

* Thu Jun 14 2012 Paul Howarth <paul@city-fan.org> - 0.04-3
- Make sure %%{optflags} are used
- BR: perl(Cwd), perl(Data::Dumper), perl(lib), perl(Test) and perl(XSLoader)
- Require perl(XSLoader) at runtime
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.04-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Mar 16 2011 Paul Howarth <paul@city-fan.org> - 0.04-1
- Initial RPM version
